#include "dmoeff.h"
#include <dmodshow.h>
#include <dmo.h>

#define RELEASE(p)	if (p){p->Release();p=NULL;}

int		g_eff_idx = 0;						// IꂽGtFNgԍ
int		g_eff_ct = 0;						// 񋓂ꂽGtFNg
GUID	g_eff_guid[MAX_EFFECT] = {NULL};	// GtFNgCLSID
char	g_eff_name[MAX_EFFECT][64] = {""};	// GtFNg̃th

bool	Add_EffectDMO_Filter(IGraphBuilder *pGB, GUID clsidDMO, WCHAR *filterName);
bool	Enum_Effect();

bool Add_EffectDMO_Filter(IGraphBuilder *pGB, GUID clsidDMO, WCHAR *filterName)
{
	HRESULT		hr;
	IBaseFilter *pDmo;
	hr = CoCreateInstance(CLSID_DMOWrapperFilter, NULL, 
				CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void**)&pDmo);
	if(SUCCEEDED(hr)){
		IDMOWrapperFilter	*pDmoWrap;
		hr = pDmo->QueryInterface(IID_IDMOWrapperFilter, (void**)&pDmoWrap);
		if(SUCCEEDED(hr)){
			hr = pDmoWrap->Init(clsidDMO, DMOCATEGORY_AUDIO_EFFECT);
			RELEASE(pDmoWrap);
			if(SUCCEEDED(hr)){
				hr = pGB->AddFilter(pDmo, filterName);
			}
		}
		RELEASE(pDmo);
		return TRUE;
	}
	return FALSE;
}// Add_EffectDMO_Filter

bool Enum_Effect()
{
	IEnumDMO* pEnum = NULL;
	HRESULT hr = DMOEnum(
						DMOCATEGORY_AUDIO_EFFECT,
						NULL,
						0, NULL, 0, NULL, &pEnum);
	strcpy(g_eff_name[0], "none");
	g_eff_ct = 1;
	if(SUCCEEDED(hr)){
		CLSID clsidDMO;
		WCHAR* wszName;
		do{
			hr = pEnum->Next(1, &clsidDMO, &wszName, NULL);
			if(hr == S_OK){
				g_eff_guid[g_eff_ct] = clsidDMO;
				WideCharToMultiByte(CP_ACP, 0, wszName, -1, g_eff_name[g_eff_ct], sizeof(g_eff_name[0]), NULL, NULL);
				CoTaskMemFree(wszName);
				g_eff_ct ++;
				if(g_eff_ct >= MAX_EFFECT){
					break;
				}
			}
		} while (hr == S_OK);
		RELEASE(pEnum);
		return TRUE;
	}
	return FALSE;
}// Enum_Effect
